#include <hartik.h>
#include <cons.h>
#include <keyb.h>

#include "netbuff.h"

#define NBUFF 5
#define DIM 2000

struct NETBUFF b;

main()
{
    int i, done;
    void *v[10];
    char c;

    sys_init(1,mSec,0);
    keyb_init(HARD,100);
    netbuff_init(&b, NBUFF, DIM);

    done = 0; i = 0;
    while (!done) {
    	c = keyb_getch(NON_BLOCK);
	if (c == 'n') {
	    v[i++] = netbuff_get(&b, NON_BLOCK);
	    cprintf("Allocated!!!  %p\n",v[i - 1]);
	}
	if (c == 'r') {
	    netbuff_release(&b, v[--i]);
	    cprintf("Released!!!\n");
	}
	if (c == 13) done = 1;
    }
    sys_end();
}
