/* Project:     HARTIK 3.0 Network Library                      */
/* Description: Hard Real TIme Kernel for 8086 compatible       */
/* Author:      Luca Abeni					*/
/* Date:        10/9/1998                                       */

/* File:        LowLev.H                                        */
/* Revision:    2.0						*/

#ifndef __LOWLEV_H__
#define __LOWLEV_H__

#ifdef __cplusplus
extern "C" {
#endif

#define NONE    0
#define UNKNOWN 1
#define VORTEX  2

void (*lowlev_info)(struct pci_regs *r);
void (*lowlev_readregs)(DWORD BaseAddress);
PID  (*lowlev_open)(unsigned long int BaseAddress, int mode);
void (*lowlev_close)(DWORD BaseAddress);
void (*lowlev_send)(DWORD BaseAddress, DWORD *txbuff, int len);

#ifdef __cplusplus
};
#endif

#endif

