#define ENABLE 1
#define DISABLE 0

#define PIO_OP		0x00
#define DMA_OP		0x01

#define PCM8		0x00
#define PCM16		0x02

#define SYNCH		0x00
#define ASYNCH		0x04

#define MYFUN		0x08
#define NOBUFF		0x10

#define STATBUFF	0x00
#define DYNBUFF		0x20

#define IN		0
#define OUT		1


#define BUFFSIZE 0xFFFF /* esattamente un segmento */
#define TICK /*91*/ 100

void sound_setfun(int (*infun)(BYTE *rawbuff), int (*outfun)(BYTE *rawbuff));
void sound_play(BYTE *b, DWORD sps, DWORD len, BYTE t);
void sound_sample(BYTE *buff, DWORD sps, DWORD len, BYTE t);
void sound_wait(void);
void sound_stop(void);
void sound_init(WORD rawbuffsize, WORD tick);
void sound_info(void);
int dummyfun1(struct dma_buff *d);
int dummyfun2(struct dma_buff *d);

#define SOUND_ERROR_BASE		150
#define SOUND_CARD_NOT_FOUND		(SOUND_ERROR_BASE+0)
#define SOUND_RAWFUN_NOT_SET		(SOUND_ERROR_BASE+1)
#define SOUND_TICK_TOO_LARGE		(SOUND_ERROR_BASE+2)
#define SOUND_ASYNCH_WAIT		(SOUND_ERROR_BASE+3)
