/*----------------------------------------------------------------------*/
/* File: cost.h								*/
/* Contiene la definizione delle costanti usate nel file pend.c		*/
/*----------------------------------------------------------------------*/

/* CVS $Id: cost.h,v 1.1 1999/07/09 11:21:25 massy Exp $ */

#define MAXREF	10	/* valore assoluto max per i riferimenti	*/
#define XMED	250	/* ascissa media delle finestre dei pendoli	*/ 
#define LC	20	/* semi-lunghezza carrello			*/
#define H	10	/* altezza carrello				*/
#define LA	80	/* lunghezza asta				*/
#define RAGGIO	2	/* raggio ruote carrello e massa sull'asta	*/
#define SGX	8	/* amplificazione spostamento lungo l'asse X	*/
#define MAXPEN	4	/* numero massimo di pendoli			*/

#define XTI	535	/* coord. X di base della finestra di stato	*/
#define YTI	16	/* coord. Y di base della finestra di stato	*/

#define FCA	0.0174533	/* costante di conversione rad./gradi	*/
#define SGA	5.5		/* fattore amplificazione angoli	*/ 
#define STEP	5		/* incremento per i riferimenti		*/
/*----------------------------------------------------------------------*/
