/*
 * file.c
 *
 * Author: Massimiliano Giorgi
 * Date: 10/5/99
 */

/* CVS $Id: file.c,v 1.2 1999/07/16 09:15:47 massy Exp $ */

#include <sys/kern.h>
#include <sys/sys.h>
#include <sys/vm.h>
#include <xdos.h>
#include <cons.h>
#include <keyb.h>

#define BUFFERSIZE 8192
char buffer[BUFFERSIZE];

int main(int argc, char *argv[])
{
  SYS_PARMS sys=BASE_SYS;
  DOS_FILE *fin,*fout;
  DWORD res;
  int i;
   
/*
 * Read a file
 */
   
  fin=DOS_fopen("file.c","r");
  if (fin==NULL) exit(-1);
  res=DOS_fread(buffer,sizeof(char),BUFFERSIZE,fin);
  DOS_fclose(fin);

/* 
 * System initialization
 */
   
  sys_init(&sys);
   
/*
 * Computing
 */
  
  /* change chars to uppercase */ 
  for (i=0;i<res;i++)
     if (buffer[i]>='a'&&buffer[i]<='z')
         buffer[i]+='A'-'a';
   
  /* write on screen */ 
  for (i=0;i<res;i++)
     cprintf("%c",buffer[i]);
   
/*
 * System end
 */ 
   
  sys_end();
   
/*
 *  Write file
 */
   
  fout=DOS_fopen("file.c2","w");
  if (fout==NULL) exit(-1);
  res=DOS_fwrite(buffer,sizeof(char),res,fout);
  DOS_fclose(fout);

  return 0;
}
