typedef struct dma_buff{
    BYTE *p;
    DWORD len;
    DWORD count;
    BYTE page;
    BYTE *dma_buff;
    WORD dma_bufflen;
} DMA_BUFF;

BYTE *dma_getpage(DWORD dim);

void dma_start(BYTE channel);
void dma_setmode(BYTE channel, BYTE mode);
void dma_setbuff(BYTE channel, BYTE *addr, WORD len);
void dma_reset(void);
void dma16_start(BYTE channel);
void dma16_setmode(BYTE channel, BYTE mode);
void dma16_setbuff(BYTE channel, BYTE *addr, WORD len);
void dma16_reset(void);

void dma_getalignbuff(struct dma_buff *buff, WORD len);
void dma_out(BYTE channel, struct dma_buff *b);
void dma_in(BYTE channel, struct dma_buff *b);
void dma_stop(BYTE channel);
void dma16_out(BYTE channel, struct dma_buff *b);
void dma16_in(BYTE channel, struct dma_buff *b);
void dma16_stop(BYTE channel);

int infun(struct dma_buff *b);
int outfun(struct dma_buff *b);

