/* Project:     HARTIK 3.0                                      */
/* Description: Hard Real TIme Kernel for 8086 compatible       */
/* Authors:     Gerardo Lamastra (lamastra@sssup2.sssup.it)     */
/*              Giuseppe Lipari  (lipari@sssup2.sssup.it)       */
/* Date:        1/10/96                                         */

/* DEC Alpha support by Antonino Casile                         */
/* Project coordinated by Giorgio Buttazzo                      */

/* Please DO NOT USE MicroSoft compilers with HARTIK+           */
/* BOYCOTT B. G.!	                                        */

#ifndef __HARTIK_H__
#define __HARTIK_H__

#ifndef __HW_DEP_H__
#include "hw_dep.h"
#endif

#ifndef __CONFIG_H__
#include "config.h"
#endif

#define __KERN_VERSION__ 	"3.3.0"

/* ------------------------------------------------------------ */
/*    The kernel layer interface & general primitive support	*/
/* ------------------------------------------------------------ */

#ifndef __KERN_H__
#include "kern.h"
#endif

/* ------------------------------------------------------------ */
/*                         Port Support                         */
/* ------------------------------------------------------------ */

#ifndef __PORT_H__
#include "port.h"
#endif

/* ------------------------------------------------------------ */
/*                         CAB Support                          */
/* ------------------------------------------------------------ */

#ifndef __CAB_H__
#include "cabs.h"
#endif

/* ------------------------------------------------------------ */
/*                         SRP Support                          */
/* ------------------------------------------------------------ */

#ifndef __SRP_H__
#include "srp.h"
#endif

#endif
