/*
 * Virtual operation on a PS/2 mouse
 * (for mouse.c)
 *
 */

/* CVS $Id: ps2mouse.h,v 1.5 1999/06/01 14:02:16 massy Exp $ */

#ifndef __PS2MOUSE_H__
#define __PS2MOUSE_H__

#include <mouse.h>

extern int C8042_ps2mousepresent(void);
#define ps2mouse_present() C8042_ps2mousepresent()

int  ps2mouse_open(void *);
void ps2mouse_close(void);
void ps2mouse_wait(void);
int  ps2mouse_get(BYTE *);
void ps2mouse_enable(void);
void ps2mouse_disable(void);

//extern TASK ps2mouse_server(void);
extern TASK (*ps2mouse_getserveraddr(void))(void);

extern int M_ps2(MOUSE_EVT *evt, unsigned char *data);

#endif
