/*
 * Virtual operation for a serial mouse
 * (for mouse.c)
 *
 * CVS $Id: sermouse.h,v 1.5 1999/06/01 14:02:16 massy Exp $
 *
 * Initial date: 22/mar/1999
 */

#ifndef __SERMOUSE_H__
#define __SERMOUSE_H__

#include <mouse.h>

typedef struct sermouse_info {
  int type;       /* MSMOUSE, MMMOUSE,... */
  int port;       /* COM1,COM2,... */
  PID pid;        /* task PID */
} SERMOUSE_INFO;

SERMOUSE_INFO *sermouse_present(void);

//extern TASK microsoftmouse_server(void);
//extern TASK mousesystem_server(void);
TASK (*sermouse_getserveraddr(SERMOUSE_INFO *))(void);

int  sermouse_open(void*);
void sermouse_close(void);
void sermouse_wait(void);
int  sermouse_get(BYTE *);
void sermouse_enable(void);
void sermouse_disable(void);

int M_ms(MOUSE_EVT *evt,unsigned char *data);
int M_ms_plus(MOUSE_EVT *evt,unsigned char *data);
int M_ms_plus_lr(MOUSE_EVT *evt,unsigned char *data);
int M_bare(MOUSE_EVT *evt,unsigned char *data);
int M_msc(MOUSE_EVT *evt,unsigned char *data);
int M_sun(MOUSE_EVT *evt,unsigned char *data);
int M_mm(MOUSE_EVT *evt,unsigned char *data);
int M_logi(MOUSE_EVT *evt,unsigned char *data);

#endif
