#include <hartik.h>
#include "gd.h"

void gd_getcolor(BYTE ind, BYTE *r, BYTE *g, BYTE *b)
{
    VM_out(0x3c7, ind);
    *r = VM_in(0x3c9);
    *g = VM_in(0x3c9);
    *b = VM_in(0x3c9);
}

void gd_setcolor(BYTE ind,BYTE r,BYTE g,BYTE b)
{
    VM_out(0x3c8, ind);
    VM_out(0x3c9, r);
    VM_out(0x3c9, g);
    VM_out(0x3c9, b);
}

void gd_getpalette(BYTE start, BYTE num, BYTE *pal)
{ 
    int i;

    for (i = start; i < start + num; i++) {
	VM_out(0x3c7, i);
	*pal++ = VM_in(0x3c9);
	*pal++ = VM_in(0x3c9);
	*pal++ = VM_in(0x3c9);
    }
}

void gd_setpalette(BYTE start, BYTE num, BYTE *pal)
{ 
    int i;

    for (i = start; i < start + num; i++) {
	VM_out(0x3c8, i);
	VM_out(0x3c9, *pal++);
	VM_out(0x3c9, *pal++);
	VM_out(0x3c9, *pal++);
    }
}
