;* Project:     HARTIK 3.0 Network Library                      
;* Description: Hard Real TIme Kernel for 8086 compatible       
;* Author:      Luca Abeni					
;* Date:        4/12/1997                                       

;* File: 	P16.Asm
;* Revision:    2.0						

; Support for 32 bits inp / outp... This is a flaw
; since 16 bit system cannot do so! We have included it into the
; network library only to test the 16 bit network implementation
; In real 16 bit networked system PCI is not available, so the
; modules which use 32 bit port addressing cannot be used!

.386

PUBLIC inpd_
PUBLIC outpd_

_TEXT	segment byte public 'CODE' use16
	ASSUME CS: _TEXT
	
inpd_	proc far
	mov	dx,ax
	in	eax,dx
	ror	eax,16
	mov	dx,ax
	rol	eax,16
	ret
inpd_	endp

outpd_ proc far
	 push dx
	 mov	dx,ax
	 mov	ax,cx
	 shl	eax,16
	 mov	ax,bx
	 out	dx,eax
	 pop dx
	 ret
outpd_ endp

_TEXT	ends
end
