/* Project:     HARTIK 3.0                                      */
/* Description: Hard Real TIme Kernel for 80x86 compatible	*/
/* Author:      Gerardo Lamastra                                */
/* Date:        4/6/98                                          */

/* File: 	Config.H					*/
/* Revision:    1.0						*/

#ifndef __CONFIG_H__
#define __CONFIG_H__

/*
 Gerardo!
 On upper Intel CPUs it is possible to avoid CPU power consumption
 when the system is idle issuing the hlt instruction!
 This is often available on many 32 bit CPUs!!
 If not, simply comment the following!!
*/
/* #define __HLT_WORKS__ */

#define __CAB__
#define __PORT__
#define __SRP__
/* #define __TRACE__ */

/* if defined:
 * the X_callBIOS() is modified to disable interrupt controller
 * and to call registered function after/before the call
 * */
/* #define __SAFEXBIOS__ */

#endif

