#ifndef __GLIB_H__
#define __GLIB_H__

#include <gd.h>

int grx_init(void);
int grx_setmode(WORD mode);
int grx_close(void);
extern void (*grx_plot)(WORD x, WORD y, DWORD color);
extern DWORD (*grx_getpixel)(WORD x, WORD y);
extern void (*grx_getimage)(WORD x1, WORD y1, WORD x2, WORD y2, BYTE *img);
extern void (*grx_putimage)(WORD x1, WORD y1, WORD x2, WORD y2, BYTE *img);
extern void (*grx_box)(WORD x1, WORD y1, WORD x2, WORD y2, DWORD color);
extern void (*grx_rect)(WORD x1, WORD y1, WORD x2, WORD y2, DWORD color);
extern void (*grx_line)(WORD x1, WORD y1, WORD x2, WORD y2, DWORD color);
extern void (*grx_text)(char *text, WORD x, WORD y, DWORD fg, DWORD bg);
extern void (*grx_circle)(WORD x, WORD y, WORD r, DWORD col);
extern void (*grx_disc)(WORD x, WORD y, WORD r, DWORD col);

void grx_modeinfo(void);
int grx_getmode(WORD x, WORD y, BYTE depth);
void grx_cardinfo(void);

void grx_setcolor(BYTE ind,BYTE r,BYTE g,BYTE b);
void grx_getcolor(BYTE ind, BYTE *r, BYTE *g, BYTE *b);
void grx_setpalette(BYTE start, BYTE num, BYTE *pal);
void grx_getpalette(BYTE start, BYTE num, BYTE *pal);

int grx_open(WORD x, WORD y, BYTE depth);

void grx_clear(DWORD color);
#endif
