/* Project: 	HARTIK 3.0      				*/
/* Description: Hard Real TIme Kernel for 386 & higher machines */
/* Author:	Gerardo Lamastra				*/
/* Date:	9/5/96 						*/
/* Revision:	2.0						*/

/* File: TSS-Ctx.H
   Macro for CONTEXT <-> TSS Translation
*/

#ifndef __CONST_H__
#include "const.h"
#endif

#define TSSMax                  MAX_PROC
#define TSSMain                 (TSSMax-1)
#define TSSBase                 0x100
#define TSSsel2index(sel)       ((sel-TSSBase)/8)
#define TSSindex2sel(i)         (TSSBase + i*8)
