/* Project: 	HARTIK 3.0      				*/
/* Description: Hard Real TIme Kernel for 386 & higher machines */
/* Author:	Gerardo Lamastra				*/
/* Date:	9/5/96 						*/
/* Revision:	2.0						*/

/* File: StdLib.C			*/
/* Standard library for X applications 	*/

/* Common use routines; included is a random number generator */

#include <stdlib.h>
#include <xsys.h>

unsigned abs(int x)
{
    if (x < 0) return(-x);
    else return(x);
}

void exit(int code)
{
    extern void bios_restore(void);

    bios_restore();
    _exit(code);
}
