/* Project: 	HARTIK 3.0     					*/
/* Description: Hard Real TIme Kernel for 386 & higher machines */
/* Author:	Gerardo Lamastra				*/
/* Date:	9/5/96 						*/
/* Revision:	Beta 1.4					*/

/* Module: X_Stub.H						*/
/* Miscellaneous functions prototypes!				*/

/* Exported function from X_Switch.Asm 					*/
/* Any address used in this functions refers to Flat memory 		*/
/* The interface toward assembler calls is based upon the standard      */
/* C calling convention (__cdecl modifier)				*/

void __cdecl x_memcpy(DWORD dst,DWORD src,DWORD cnt);
WORD __cdecl x_memcmp(DWORD dst,DWORD src,DWORD cnt);
void __cdecl x_memset(DWORD dst,WORD value,DWORD cnt);
WORD __cdecl x_call32(WORD sel,DWORD offset);

/* From RM Segment:Offset -> PM Linear address */

DWORD LINEARIZE(void __far *address);

/* Table management functions */

void ins_gate(WORD id,void *where,WORD s,DWORD o,BYTE a,BYTE wc);
void ins_descr(WORD id,DWORD b,DWORD l,BYTE a,BYTE g);

/* Info structure */
extern struct info X_info;

/* This is the RM loading buffer */
#define BUFSIZE 8129
extern BYTE load_buf[BUFSIZE];


